/*
* +--------------------------------------------------------------------------+
* | Copyright (c) 2007 Clearspring Technologies               |
* +--------------------------------------------------------------------------+
* | Unless required by applicable law or agreed to in writing, this software |
* | is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF |
* | ANY KIND, either expressed or implied.                  |
* +--------------------------------------------------------------------------+
*/

var WIDGET_WID = "48cfc2451cfb95ce";
var WIDGET_PID = "48cfc2451cfb95ce";

const WIDGET_WIDTH = 300;
const WIDGET_HEIGHT = 400;

const LOADINGSCREEN_WIDTH = 80;
const LOADINGSCREEN_HEIGHT = 24;

const OFFLINE_CHECK_INTERVAL = 10;

const IS_FLASH_WIDGET = true;
const IS_TRANSPARENT = true;

var g_timer = new Timer();
var g_lightbox = null;

function checkPID( ) {
				
	if(WIDGET_PID == null) {
		// Try to get a PID from the preferences from a previous grab
		// If we had a PID before, we can use it again
		WIDGET_PID = preferences.widgetPid.value;
		
		// If we got one, go to loadComplete
		if(WIDGET_PID != 0) {
			var xmlHttp = new XMLHttpRequest();
			
			print("DEBUG: PID pulled from cached preferences. PID = " + WIDGET_PID);
			
			// A ping if we already have a WID		
//			xmlHttp.open("GET", "http://widgets.clearspring.com/current/d/yahoowidgets/p/?wid="+WIDGET_WID+"&pid="+WIDGET_PID+"&_cs_do_not_generate=1", true);	
//			xmlHttp.send(null);				
			
			loadComplete();
			return;
		}
				
		var xmlHttp = new XMLHttpRequest();
		xmlHttp.open("GET", "http://widgets.clearspring.com/current/d/yahoowidgets/p/?wid="+WIDGET_WID, true);
		
		xmlHttp.onreadystatechange=function() {
			
			if (xmlHttp.readyState < 4) return;
			        if(xmlHttp.status==200) {
						WIDGET_PID = xmlHttp.responseText;
						if(WIDGET_PID == "0") WIDGET_PID = WIDGET_WID;
						
						print("DEBUG: PID received dynamically. PID = " + WIDGET_PID);
						
						// Write to preferences when we get the new pid
						preferences.widgetPid.value = WIDGET_PID;
						savePreferences();
						loadComplete();
						return;
			        } else {
						// Do not write to preferences.  We can try to get a PID again next time
						// Just set the PID to the WID
						
						WIDGET_PID = WIDGET_WID;
						print("DEBUG: PID dynamic query failed. PID = WID = " + WIDGET_PID);
						loadComplete();
						return;
			        }
		};
		
		xmlHttp.send(null);	
	} else {
		var xmlHttp = new XMLHttpRequest();
		
		// A ping if we already have a PID		
//		xmlHttp.open("GET", "http://widgets.clearspring.com/current/d/yahoowidgets/p/?wid="+WIDGET_WID+"&pid="+WIDGET_PID+"&_cs_do_not_generate=1", true);	
//		xmlHttp.send(null);	
		
		print("DEBUG: PID included in widget. PID = " + WIDGET_PID);
		
		loadComplete();	
		return;	
	}
	
}

function checkConnectivity( callback ) {
        g_timer.ticking = true;
        var xmlHttp = new XMLHttpRequest();

		// Generate a random number so we don't get cached content
		var randomnumber=Math.floor(Math.random()*1000000);

        xmlHttp.open("GET", "http://widgets.clearspring.com/ping?" + randomnumber, true);

        xmlHttp.onreadystatechange=function() {

                        if (xmlHttp.readyState < 4) return;
                                if(xmlHttp.status==200) {
                                        g_timer.ticking = false;
										print("DEBUG: Widet is online. Loading content.");
                                        checkPID();
                                } else {
										print("DEBUG: Widet is offline. Checking again in " + OFFLINE_CHECK_INTERVAL + " seconds.");
                                        g_timer.interval = OFFLINE_CHECK_INTERVAL;
                                        g_timer.onTimerFired = checkConnectivity;
                                        g_timer.ticking = true;
                                }
                };

        xmlHttp.send(null);
}

function createBGImage( ) {
	g_bgImage = new Image();
		g_bgImage.width = WIDGET_WIDTH;
		g_bgImage.height = WIDGET_HEIGHT;
		g_bgImage.src = "images/screenshot.png";
		g_bgImage.name = "g_bgImage";
		g_bgImage.hOffset = 0;
		g_bgImage.vOffset = 0;
		g_bgImage.opacity = 255;
	mainWindow.appendChild(g_bgImage);		
}

function createLoadingScreen() {
	g_loadingScreen = new Flash( );
		g_loadingScreen.id = "loadingScreen";
		g_loadingScreen.src = "images/loading.swf";
		g_loadingScreen.width = LOADINGSCREEN_WIDTH;
		g_loadingScreen.height = LOADINGSCREEN_HEIGHT;
		
		g_loadingScreen.vOffset = (WIDGET_HEIGHT / 2.0) - (LOADINGSCREEN_HEIGHT / 2.0);
		g_loadingScreen.hOffset = (WIDGET_WIDTH / 2.0) - (LOADINGSCREEN_WIDTH / 2.0);
		g_loadingScreen.bgColor = "#222222";
		g_loadingScreen.visible = true;		
	mainWindow.appendChild( g_loadingScreen );
}

function createLightbox() {
	g_lightbox = new Canvas();
	g_lightbox.width = WIDGET_WIDTH;
	g_lightbox.height = WIDGET_HEIGHT;
	var ctx = g_lightbox.getContext("2d");
	ctx.fillStyle = "#000000";
	g_lightbox.style.opacity = .80;
	ctx.fillRect(0,0,g_lightbox.width, g_lightbox.height);
	mainWindow.appendChild(g_lightbox);
}

function removeLightbox() {
	mainWindow.removeChild(g_lightbox);
	delete(g_lightbox);
	g_lightbox = null;	
}

function linkoutException(event) {
	if(event.data.length > 12 && event.data.substr(0,12) == "_cs_linkout_") {
		var link = event.data.substr(12, event.data.length);
		openURL(link);	
	} else {
		log("Exception thrown: " + link);
	}
} 