/*
* +--------------------------------------------------------------------------+
* | Copyright (c) 2007 Clearspring Technologies               |
* +--------------------------------------------------------------------------+
* | Unless required by applicable law or agreed to in writing, this software |
* | is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF |
* | ANY KIND, either expressed or implied.                  |
* +--------------------------------------------------------------------------+
*/

const SHARETAB_WIDTH = 157;
const SHARETAB_HEIGHT = 19;

const SHARELABEL_WIDTH = 135;
const SHARELABEL_HEIGHT = 19;

const SHAREMENU_WIDTH = 160;
const SHAREMENU_HEIGHT = 235;

const HAS_INTERNAL_DOCK = true;

const TEMPLATE_NAME = "template2.as3.swf";
const IS_UNITY = false;
const UNITY_MENUTEMPLATE = "m.template2.swf";

var g_sharetabFrame = null;
var g_sharetabBgImage = null;
var g_sharetabShareActive = null;
var g_sharetabShareInactive = null;
var g_flashShare = null;

var g_oldMainWindowHeight = 0; // placeholder for old height if we resize

function createShareMenu() {

	g_sharetabFrame = new Frame();
		g_sharetabFrame.opacity = 0;
	mainWindow.appendChild(g_sharetabFrame);

	g_sharetabImage = new Image();
		g_sharetabImage.width = SHARETAB_WIDTH;
		g_sharetabImage.height = SHARETAB_HEIGHT;
		
		if(!HAS_INTERNAL_DOCK)
			g_sharetabImage.src = "images/cs_desktop_widget_bg.png";
		else 
			g_sharetabImage.src = "images/cs_desktop_widget_bg_noshare.png";
		
		g_sharetabImage.name = "g_sharetabImage";
		g_sharetabImage.hOffset = (WIDGET_WIDTH / 2.0) - (SHARETAB_WIDTH / 2.0);
		g_sharetabImage.vOffset = WIDGET_HEIGHT;
		g_sharetabImage.opacity = 255;
	g_sharetabFrame.appendChild(g_sharetabImage);
	
	if(!HAS_INTERNAL_DOCK) {
		g_sharetabShareActive = new Image();
			g_sharetabShareActive.width = SHARELABEL_WIDTH;
			g_sharetabShareActive.height = SHARELABEL_HEIGHT;
			g_sharetabShareActive.src = "images/cs_desktop_widget_getshare_on.png";
			g_sharetabShareActive.name = "g_sharetabShareActive";
			g_sharetabShareActive.hOffset = g_sharetabImage.hOffset + (SHARETAB_WIDTH - SHARELABEL_WIDTH);
			g_sharetabShareActive.vOffset = g_sharetabImage.vOffset;
			g_sharetabShareActive.opacity = 0;
			g_sharetabShareActive.onMouseEnter = function( event ) { doGainFocusShareicon(); }
			g_sharetabShareActive.onMouseExit = function( event ) { doLoseFocusShareicon(); }			
			g_sharetabShareActive.onClick = function( event ) { doClickShare(); }
		g_sharetabFrame.appendChild(g_sharetabShareActive);
	
		g_sharetabShareInactive = new Image();
			g_sharetabShareInactive.width = SHARELABEL_WIDTH;
			g_sharetabShareInactive.height = SHARELABEL_HEIGHT;
			g_sharetabShareInactive.src = "images/cs_desktop_widget_getshare_off.png";
			g_sharetabShareInactive.name = "g_sharetabShareInactive";
			g_sharetabShareInactive.hOffset = g_sharetabImage.hOffset + (SHARETAB_WIDTH - SHARELABEL_WIDTH);
			g_sharetabShareInactive.vOffset = g_sharetabImage.vOffset;
			g_sharetabShareInactive.opacity = 255;
			g_sharetabShareActive.onClick = function( event ) { doClickShare(); }
			g_sharetabShareInactive.onMouseEnter = function( event ) { doGainFocusShareicon(); }
			g_sharetabShareInactive.onMouseExit = function( event ) { doLoseFocusShareicon(); }
		g_sharetabFrame.appendChild(g_sharetabShareInactive );
	
		g_sharetabCancelActive = new Image();
			g_sharetabCancelActive.width = SHARELABEL_WIDTH;
			g_sharetabCancelActive.height = SHARELABEL_HEIGHT;
			g_sharetabCancelActive.src = "images/cs_desktop_widget_cancel_on.png";
			g_sharetabCancelActive.name = "g_sharetabShareActive";
			g_sharetabCancelActive.hOffset = g_sharetabImage.hOffset + (SHARETAB_WIDTH - SHARELABEL_WIDTH);
			g_sharetabCancelActive.vOffset = g_sharetabImage.vOffset;
			g_sharetabCancelActive.opacity = 0;
			g_sharetabCancelActive.visible = false;
			g_sharetabCancelActive.onMouseEnter = function( event ) { doGainFocusShareicon(); }
			g_sharetabCancelActive.onMouseExit = function( event ) { doLoseFocusShareicon(); }			
			g_sharetabCancelActive.onClick = function( event ) { doClickShare(); }
		g_sharetabFrame.appendChild(g_sharetabCancelActive);
	
		g_sharetabCancelInactive = new Image();
			g_sharetabCancelInactive.width = SHARELABEL_WIDTH;
			g_sharetabCancelInactive.height = SHARELABEL_HEIGHT;
			g_sharetabCancelInactive.src = "images/cs_desktop_widget_cancel_off.png";
			g_sharetabCancelInactive.name = "g_sharetabShareInactive";
			g_sharetabCancelInactive.hOffset = g_sharetabImage.hOffset + (SHARETAB_WIDTH - SHARELABEL_WIDTH);
			g_sharetabCancelInactive.vOffset = g_sharetabImage.vOffset;
			g_sharetabCancelInactive.opacity = 0;
			g_sharetabCancelInactive.visible = false;
			g_sharetabCancelInactive.onClick = function( event ) { doClickShare(); }
			g_sharetabCancelInactive.onMouseEnter = function( event ) { doGainFocusCancelicon(); }
			g_sharetabCancelInactive.onMouseExit = function( event ) { doLoseFocusCancelicon(); }
	
		g_sharetabFrame.appendChild(g_sharetabCancelInactive );		
	}
}


function doClickShare() {
	if(g_flashShare == null) {
		g_flashShare = new Flash( );
			g_flashShare.id = "g_flashShare";
			g_flashShare.src = "http://widgets.clearspring.com/o/"+WIDGET_WID+"/"+WIDGET_PID+"/-/-DBL/1/-DWE/3/-FLG/80000/m.template2.swf?_cs_standalone=true&_cs_dockless=true";
			g_flashShare.width = SHAREMENU_WIDTH;
			g_flashShare.height = SHAREMENU_HEIGHT;
			g_flashShare.allowNetworking="all";
			g_flashShare.allowScriptAccess="always";
			g_flashShare.scale = 1;
			g_flashShare.vOffset = WIDGET_HEIGHT - SHAREMENU_HEIGHT + 20;
			g_flashShare.hOffset = (WIDGET_WIDTH / 2.0) - (SHAREMENU_WIDTH / 2.0);
			g_flashShare.opacity = 255;
			g_flashShare.visible = true;
			g_flashShare.sAlign = "tl";
		
		// change for unity	
		if (IS_UNITY) {
			if (WIDGET_HEIGHT > SHAREMENU_HEIGHT) {
				g_flashShare.vOffset = 0;
				g_flashShare.hOffset = 0;
				g_flashShare.width = WIDGET_WIDTH;
				g_flashShare.height = WIDGET_HEIGHT;			
			}
			g_flashShare.src = "http://widgets.clearspring.com/o/"+WIDGET_WID+"/"+WIDGET_PID
							+"/-/-DBL/1/-DWE/3/-FLG/80000"
							+"/-MSH/"+WIDGET_HEIGHT+"/-MSW/"+WIDGET_WIDTH
							+"/-EMH/"+WIDGET_HEIGHT+"/-EMW/"+WIDGET_WIDTH
							+"/-H/"+WIDGET_HEIGHT+"/-W/"+WIDGET_WIDTH
							+"/-MSA/1/-BF0/1073815536/m.template2.swf";
		}
			
		if(WIDGET_HEIGHT < SHAREMENU_HEIGHT) {
			g_flashShare.vOffset = WIDGET_HEIGHT + 18;
			g_oldMainWindowHeight = mainWindow.height;
			mainWindow.height = SHAREMENU_HEIGHT + SHARETAB_HEIGHT + WIDGET_HEIGHT;			
		}
			
			
		mainWindow.appendChild( g_flashShare);
		g_sharetabFrame.orderAbove(g_flashShare);
		g_sharetabCancelInactive.opacity = 255;
		g_sharetabShareInactive.visible = false;
		g_sharetabShareActive.visible = false;

		g_sharetabCancelInactive.visible = true;
		g_sharetabCancelActive.visible = true;	
	} else {
		g_sharetabCancelInactive.visible = false;
		g_sharetabCancelActive.visible = false;

		g_sharetabShareInactive.visible = true;
		g_sharetabShareActive.visible = true;	

		mainWindow.removeChild( g_flashShare );
		g_flashShare = null;
		
		if(WIDGET_HEIGHT < SHAREMENU_HEIGHT) {
			mainWindow.height = g_oldMainWindowHeight;
		}
	}
}

function doGainFocusSharetab() {
		animator.start(new FadeAnimation( g_sharetabFrame, 255, 550, animator.kEaseInOut ));
}

function doLoseFocusSharetab() {
	if(g_flashShare == null)
		animator.start(new FadeAnimation( g_sharetabFrame, 0, 550, animator.kEaseInOut ));
}

function doGainFocusShareicon() {
	doGainFocusSharetab();
	animator.start(new FadeAnimation( g_sharetabShareActive, 255, 200, animator.kEaseInOut ));
	animator.start(new FadeAnimation( g_sharetabShareInactive, 0, 200, animator.kEaseInOut ));
}

function doLoseFocusShareicon() {
	animator.start(new FadeAnimation( g_sharetabShareActive, 0, 200, animator.kEaseInOut ));
	animator.start(new FadeAnimation( g_sharetabShareInactive, 255, 200, animator.kEaseInOut ));
}

function doGainFocusCancelicon() {
	doGainFocusSharetab();
	animator.start(new FadeAnimation( g_sharetabCancelActive, 255, 200, animator.kEaseInOut ));
	animator.start(new FadeAnimation( g_sharetabCancelInactive, 0, 200, animator.kEaseInOut ));
}

function doLoseFocusCancelicon() {
	animator.start(new FadeAnimation( g_sharetabCancelActive, 0, 200, animator.kEaseInOut ));
	animator.start(new FadeAnimation( g_sharetabCancelInactive, 255, 200, animator.kEaseInOut ));
}
